unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    StatusBar1: TStatusBar;
    Label2: TLabel;
    ListBox1: TListBox;
    Button2: TButton;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses tsutil;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if not (key in ['0'..'9',#8]) then
    key:=#0;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if edit1.text<>'' then
  begin
    StatusBar1.SimpleText:='logging off user...';
    showmessage('Success? : '+booltostr(WTSLogoffSession(WTS_CURRENT_SERVER_HANDLE,strtoint(edit1.text),true),true));
    StatusBar1.SimpleText:='done. error code: '+inttostr(GetLastError);
    button2.click;
  end;                                                                 
end;

procedure TForm1.Button2Click(Sender: TObject);
var s:PWTS_SESSION_INFO;
    si:WTS_SESSION_INFO;
    c:dword;
    i:integer;
    res:boolean;
begin
  StatusBar1.SimpleText:='refreshing...';
  res:=WTSEnumerateSessions(WTS_CURRENT_SERVER_HANDLE, 0, 1, s, c);
  if res then
  begin
    listbox1.clear;
    listbox1.items.add('SessionID/Station/State');
    for i:=1 to c do
    begin
      si:=PWTS_SESSION_INFO(integer(s)+(i-1)*sizeof(WTS_SESSION_INFO))^;
      listbox1.items.add(inttostr(si.SessionId)+'/'+si.pWinStationName+'/'+SessionStateStrings[si.State]);
    end;
    WTSFreeMemory(s);
  end;
  StatusBar1.SimpleText:='done. error code: '+inttostr(GetLastError);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  button2.Click;
end;

end.
